#include "NeckButton.h"
#include "WProgram.h"

#define OFF_STATE 0
#define ON_STATE 1
#define DEBOUNCING_TO_ON_STATE 2
#define DEBOUNCING_TO_OFF_STATE 3

NeckButton::NeckButton(int button)
{
  this->button = button;
  pinMode(button, INPUT);
  digitalWrite(button, HIGH); // turn on the pull-up resistor
  this->state = OFF_STATE;
}

void NeckButton::checkForEvent()
{
  int val = digitalRead(button);
  if(state == OFF_STATE && val == LOW)
  {
    state = ON_STATE;
    onPress();
  }
  else if(state == ON_STATE && val == LOW)
  {
    onHold();
  }
  else if(state == ON_STATE && val == HIGH)
  {
    state = OFF_STATE;
    onRelease();
  }
}

void NeckButton::onPress() { }
void NeckButton::onHold() { }
void NeckButton::onRelease() { }
