#ifndef TRIGGER_H
#define TRIGGER_H

#include "electric_funkatron.h"

class Trigger
{
private:
  int pin;
  int note;
  int state;
  unsigned long offTime;
  unsigned long holdtime;
  int threshold;
  int vel_scale;
  
public:
  Trigger();
  
  // pin: Arduino MEGA pin
  // n: NOTE struct associated with the pin
  Trigger(int pin, NOTE n);
  ~Trigger();
  
  // Checks to see if this Trigger has been hit and generates the
  // appropriate MIDI events (if any)
  void process();

  // emergency stop for this trigger -- turn off in case it hangs
  void sendNoteOff();
  
private:
  void init(int pin, NOTE n);
  void checkInput();
  void checkNoteOff();
};

#endif
