#ifndef ELECTRIC_FUNKATRON_H
#define ELECTRIC_FUNKATRON_H

// set to 1 for debugging, 0 otherwise
#define USE_DEBUG 1

// set to 1 for velocity sensitivity, 0 for full-velocity-on-hit
#define USE_VELOCITY 1



#define ledPin     13  // for midi out status

/*                  ___
 *                 ): :(
                    | |
                    | |
                    |H|
                    |G|  /\
                  __|F|_/ |
                 /E      /
                 \     A|
                J/I    B \
                /  L     |
                |  M    /
                 \___CD/  
 */

// define the number and name of all triggers (piezo inputs) here
// should probably rename with better mnemonics to match trigger positions on the final instrucment
#define numTriggers 12
#define triggerA 3
#define triggerB 4
#define triggerC 5
#define triggerD 6
#define triggerE 7
#define triggerF 8
#define triggerG 9
#define triggerH 10
#define triggerI 11 // "trigger-eye"
#define triggerJ 12
//#define triggerK 13 // unused
#define triggerL 1
#define triggerM 2

#define DEFAULT_CROSSTALK_THRESHOLD  25
#define DEFAULT_HOLDTIME 50

/* holds values pertinent to the note itself (not hardware characteristics of the trigger) */
typedef struct
{
  int note;       // midi note value
  unsigned long hold_time;  // time, in ms, to leave the note "on"
  int vel_scale;  // use to tune the velocity.  Positive values make the note louder, negative values softer.
} NOTE;

#if USE_DEBUG
  #define DEBUG(MSG) Serial.println(MSG)
#else
  #define DEBUG(MSG)
#endif

#endif
